#! /usr/bin/perl -w
use strict;
use Getopt::Long;
use File::Path;



my $TEMP_DIR="/tmp/HPS";


######################################################################################################################
# Variablen
######################################################################################################################
$0 =~ /(.*\/+)*(.+\.pl)/;
my $location=$1;
my $scriptName=$2;
my $installer="";



######################################################################################################################
# Parse Kommandozeilen Parameter
######################################################################################################################
sub getOptions {
	GetOptions("installer=s" => \$installer) || die "Es fehlt die Angaben über das Updatepacket.";
	
	if($installer eq "") {
		print "Es fehlen Angaben zum UpdatePacket";
		exit 1;
	}
}

print "Starte Update Vorgang\n";

getOptions();

# Installationsverzeichniss anlegen
eval { mkpath($TEMP_DIR) };

if($@) {
	print "Das temporäre Verzeichnis konnte nicht angelegt werden.\n";
	print $@."\n";
	exit 1;
}

chdir($TEMP_DIR);

# Entpacke Installationspacket
my $result=system("tar xvzf $installer > /dev/null 2>&1");

if($result != 0) {
	print "Beim entpacken sind Fehler aufgetreten.\n";
	exit 1;
}

# Starte Installationsscript
$result=system("perl $TEMP_DIR/install.pl --installdir=$location --update");

if($result != 0) {
	print "Beim Installieren sind Fehler aufgetreten.\n";
	exit 1;
}

# Aufräumen
print "Aufräumen!\n";
rmtree($TEMP_DIR);

exit 0;